"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TextStyleResolver = exports.filterProps = void 0;
const react_1 = __importStar(require("react"));
const react_2 = require("@gluestack-style/react");
const react_native_1 = require("react-native");
const permittedProps = [
    // text style props
    'color',
    'fontFamily',
    'fontSize',
    'fontStyle',
    'fontWeight',
    'includeFontPaddingAndroid',
    'fontVariant',
    'letterSpacing',
    'lineHeight',
    'textAlign',
    'textAlignVerticalAndroid',
    'textDecorationColoriOS',
    'textDecorationLine',
    'textDecorationStyleiOS',
    'textShadowColor',
    'textShadowOffset',
    'textShadowRadius',
    'textTransform',
    'verticalAlignAndroid',
    'writingDirectioniOS',
    'userSelect',
    // variants
    // TODO : change this flow so it automatically taked variants from the config
    'isTruncated',
    'bold',
    'underline',
    'strikeThrough',
    'sub',
    'italic',
    'highlight',
];
function filterProps(obj) {
    const filteredObj = {};
    for (const key of Object.keys(obj)) {
        if (permittedProps.includes(key)) {
            filteredObj[key] = obj[key];
        }
        else if (typeof obj[key] === 'object') {
            const filteredNested = filterProps(obj[key]);
            if (Object.keys(filteredNested).length > 0) {
                filteredObj[key] = filteredNested;
            }
        }
    }
    return filteredObj;
}
exports.filterProps = filterProps;
const ignoreStyleType = ['boot-base', 'global'];
const TextAncestorContext = (0, react_1.createContext)({
    hasTextAncestor: false,
    stylesPassed: {},
});
class TextStyleResolver {
    // no other use
    register() { }
    constructor() {
        this.name = 'TextStyleResolver';
    }
    // @ts-ignore
    inputMiddleWare(_styledObj = {}, _shouldUpdate = true, _ = false, Component, ...args) {
        var _a;
        if (_shouldUpdate)
            this.themed = _styledObj;
        (_a = args === null || args === void 0 ? void 0 : args[1]) === null || _a === void 0 ? true : delete _a.plugins;
        this.styledComponentConfig = args;
        return [_styledObj, _shouldUpdate, _, Component];
    }
    componentMiddleWare({ Component, styleCSSIds, GluestackStyleSheet }) {
        if ((Component === null || Component === void 0 ? void 0 : Component.displayName) === 'TEXT_PLUGIN_COMPONENT') {
            return Component;
        }
        const styles = [];
        const nativeStyleMap = GluestackStyleSheet.getStyleMap();
        styleCSSIds.forEach((cssId) => {
            const nativeStyle = nativeStyleMap.get(cssId);
            if (nativeStyle && !ignoreStyleType.includes(nativeStyle.type)) {
                const styleSheet = nativeStyle === null || nativeStyle === void 0 ? void 0 : nativeStyle.resolved;
                if (styleSheet) {
                    const textStyleSheet = Object.fromEntries(Object.keys(styleSheet)
                        .filter((key) => permittedProps.includes(key))
                        .map((key) => [key, styleSheet[key]]));
                    styles.push(textStyleSheet);
                }
            }
        });
        const stylesObj = react_native_1.StyleSheet.flatten(styles);
        const StyledComponent = (0, react_2.styled)(Component, {}, ...this.styledComponentConfig);
        const TextStyledResolvedComponent = (0, react_1.forwardRef)((_a, ref) => {
            var { key, children } = _a, componentProps = __rest(_a, ["key", "children"]);
            const { stylesPassed } = (0, react_1.useContext)(TextAncestorContext);
            const finalStyle = Object.assign(Object.assign({}, stylesPassed), stylesObj);
            return (react_1.default.createElement(TextAncestorContext.Provider, { value: {
                    hasTextAncestor: true,
                    stylesPassed: finalStyle,
                } },
                react_1.default.createElement(StyledComponent, Object.assign({}, componentProps, { key: key, ref: ref, style: finalStyle }), children)));
        });
        //@ts-ignore
        TextStyledResolvedComponent.isStyledComponent = true;
        TextStyledResolvedComponent.displayName = 'TEXT_PLUGIN_COMPONENT';
        return TextStyledResolvedComponent;
    }
}
exports.TextStyleResolver = TextStyleResolver;
